<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api } from "~/common/constaint";
import AdminCollectionModule from "~/store/adminCollection";
const slugify = require("slugify");
@Component({
  components: {
    MediaPicker: () => import("../../../Gallery/MediaPicker/index.vue"),
    Tree: () => import("../TreeCollection/index.vue"),
  },
})
export default class AdminShopCategoryComponent extends Vue {
  adminCollection = getModule(AdminCollectionModule, this.$store);

  dialogMediaPicker = false;
  dialogDeleteCollection = false;

  config = {
    page: 1,
    limit: 25,
    search: "",
    filter: {},
  };
  totalPage: number = 0;

  loadingTable = false;
  selectedAll = false;
  listCollection: any = [];
  listProduct = [];
  listIds = [];
  listFilter = [
    { name: "All", value: "All" },
    { name: "This collection", value: "" },
  ];
  filter = "";
  collection = {
    name: "",
    slug: "",
    desc: "",
    collectionStatus: 1,
    listProductId: [],
  };

  collectionId = "";

  imageRender = "";
  bigCategory = false;

  collectionStatus = true;

  slug = "";
  loading = false;

  beforeDestroy() {
    this.$store.commit("adminCollection/setCoverId", {
      coverId: "",
      imageUrl: "",
    });
  }

  async mounted() {
    const { slug } = this.$route.params;
    this.slug = slug || "";
    await this.onGetDetailCollection();
    this.onGetListCollection();
    this.onGetListAllProduct();
  }

  async onGetListAllProduct() {
    try {
      this.loadingTable = true;
      const config = {
        ...this.config,
      };
      if (this.filter !== "All") {
        //@ts-ignore
        config.filter["categoryId"] = this.filter;
      } else {
        //@ts-ignore
        delete config.filter["categoryId"];
      }
      const response = await this.$api.product.getListAdmin(config);
      const { page, total, totalInList, data } = response.data;
      this.totalPage = Math.ceil(total / this.config.limit);
      if (response?.data?.data) {
        this.listProduct = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async onGetDetailCollection() {
    try {
      const response = await this.$api.collection.getDetailAdmin(this.slug);
      if (response) {
        const { collectionStatus, desc, name, slug, _id, listProductId } =
          response.data;
        this.collectionId = _id;
        this.listFilter[1].value = _id;
        this.filter = _id;

        this.collection = {
          collectionStatus,
          desc,
          name,
          slug,
          listProductId,
        };
      }
    } catch (error) {}
  }
  async onGetListCollection() {
    try {
      const response = await this.$store.dispatch(
        "adminCollection/onGetListCollection",
        {
          ctx: this,
        }
      );
      if (response.data?.data) {
        this.listCollection = response.data.data;
      }
    } catch (error) {
      console.log("error :>> ", error);
    }
  }

  async onUpdateCollection() {
    try {
      // const coverId = this.$store.state.adminCollection.coverId;
      // if (coverId) {
      // 	this.collection.coverId = coverId;
      // }
      if (
        !this.collection.name ||
        !this.collection.slug ||
        !this.collection.desc
      ) {
        return this.$pushNotification.error("Please complete all information");
      }
      // else if (!this.collection.coverId) {
      // 	return this.$pushNotification.error("Please choose a photo");
      // }
      const slug = this.generateSlug(this.collection.slug);
      this.collection.slug = slug;
      if (this.collectionStatus) {
        this.collection.collectionStatus = 1;
      } else {
        this.collection.collectionStatus = 2;
      }
      this.loading = true;
      this.collection.listProductId = this.listIds;
      await this.$api.collection.edit(this.collectionId, this.collection);
      this.$pushNotification.success("Updated collection successfully");
      this.onGetListCollection();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onDeleteCollection() {
    try {
      this.loading = true;
      await this.$api.collection.delete(this.collectionId);
      this.$pushNotification.success("Deleted collection successfully");
      this.$router.push("/admin/shop/collection");
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  onSelectImage() {
    this.dialogMediaPicker = true;
  }

  removeImage() {
    this.$store.commit("adminCollection/setCoverId", {
      coverId: "",
      imageUrl: "",
    });
    this.imageRender = "";
  }

  generateSlug(tilte: string) {
    const options = {
      replacement: "-",
      remove: undefined,
      lower: true,
      strict: false,
      locale: "en",
      trim: true,
    };
    const slug = slugify(tilte, options);
    return slug;
  }

  convertImageProduct(data: any) {
    if (data?.listImageId?.length) {
      const { imageUrl } = data.listImageId[0];
      return `${api}/${imageUrl}`;
    }
    return "";
  }

  get convertImage() {
    const imageUrl =
      this.$store.state.adminCollection.imageUrl || this.imageRender;
    if (imageUrl) {
      return `${api}/${imageUrl}`;
    }
    return "";
  }

  get findNameCollection() {
    const findCollection = this.listCollection.find(
      (col: any) => col.slug === this.slug
    );
    if (findCollection) {
      return findCollection.name;
    }
    return "";
  }

  removeAccents(str: string) {
    return str
      .normalize("NFD")
      .replace(/[\u0300-\u036f]/g, "")
      .replace(/đ/g, "d")
      .replace(/Đ/g, "D");
  }

  @Watch("collection.name")
  changedName(val: string) {
    const parseSlug = this.removeAccents(val);
    const slug = this.generateSlug(parseSlug);
    this.collection.slug = slug;
  }

  @Watch("filter")
  changedCollectionId(val: string) {
    this.onGetListAllProduct();
  }
}
</script>

<style>
.thumbnails-image {
  border: 1px dashed #0091ea;
  border-radius: 8px;
  width: 216px;
  height: 216px;
}

.thumbnails-image-selected .button-remove-image {
  position: absolute;
  top: 6px;
  right: 6px;
}

.thumbnails-image-selected {
  width: 216px;
  height: 216px;
}
.height-radio {
  height: 200px;
  overflow-y: scroll;
}
</style>
